<?php
// +-----------------------------------------------------------------------+
// | reset level plugin for piwigo by TEMMII                               |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2011-2022 ddtddt               http://temmii.com/piwigo/ |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+


add_event_handler('loading_lang', 'reset_level_loading_lang');	  
function reset_level_loading_lang(){
  load_language('plugin.lang', DELLE_PATH);
}

add_event_handler('loc_begin_admin', 'plugrlPf');
add_event_handler('loc_begin_admin_page', 'plugrlaction');

function plugrlPf(){
  global $template;
  $admin_base_url = $_SERVER['REQUEST_URI'];
  $template->set_prefilter('maintenance', 'plugrlPT');
  $template->assign(
    array(
		'U_RESETLEVEL' => $admin_base_url . '&amp;resetlevel&amp;pwg_token='.get_pwg_token(),
  ));
}

function plugrlPT($content){
  // add js link
  $search = '{/footer_script}';
  $replace = '
  $(".reset-level-button").each(function() {
  const title = \'{"Discount level of confidentiality for all photos in the gallery: for all"|@translate|@escape:\'javascript\'}\';
  $(this).pwg_jconfirm_follow_href({
    alert_title: title,
    alert_confirm: confirm_msg,
    alert_cancel: cancel_msg
  });
});
  ';
  $content = str_replace($search, $replace.$search, $content);
	
  //add action	
  $search = '<a href="{$U_MAINT_C13Y}" class="icon-ok maintenance-action">{\'Reinitialize check integrity\'|@translate}</a>';
  $replacement = '<a href="{$U_RESETLEVEL}" class="maintenance-action reset-level-button" title="{\'Discount level of confidentiality for all photos in the gallery: for all\'|@translate}"><span class="icon-arrows-cw"></span>{\'Reset levels of privacy\'|@translate}</a>';
  return str_replace($search, $search.$replacement, $content);
}

function plugrlaction(){
  if (isset($_GET['resetlevel'])){
	if (is_webmaster()){
	  $query = 'UPDATE ' . IMAGES_TABLE . ' SET level= \'0\';';
	  $result = pwg_query($query);
	  invalidate_user_cache();
	  $_SESSION['page_infos'] = array(l10n('All Photos now have a level of confidentiality "for all "'));
	}else{
	  $_SESSION['page_errors'] = array(l10n('Only webmaster can be reset privacy level'));
	}
	redirect(get_root_url().'admin.php?page=maintenance');  
  }
}